Index: EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/componentobj.rb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/componentobj.rb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/componentobj.rb	(revision 429)
@@ -4,5 +4,5 @@
 #      Generator for TOPPERS Embedded Component System
 #  
-#   Copyright (C) 2008-2016 by TOPPERS Project
+#   Copyright (C) 2008-2019 by TOPPERS Project
 #--
 #   上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
@@ -79,4 +79,8 @@
 #  @b_checked_as_allocator_signature:: bool:  アロケータシグニチャとしてチェック済み
 #  @b_empty:: Bool: 空(関数が一つもない状態)
+#  @descriptor_list:: nil | { Signature => ParamDecl }  最後の ParamDecl しか記憶しないことに注意
+#  @generate:: [ Symbol, String, Plugin ]  = [ PluginName, option, Plugin ] Plugin は生成後に追加される
+
+  include PluginModule
 
   @@nest_stack_index = -1
@@ -123,4 +127,6 @@
     @b_empty = false
     @b_checked_as_allocator_signature = false
+    @descriptor_list = nil
+    @generate = nil
     @@current_object = self
     set_specifier_list( Generator.get_statement_specifier )
@@ -136,4 +142,5 @@
     function_head_list.get_items.each{ |f|
       @func_name_to_id[ f.get_name ] = id
+      f.set_owner self
       id += 1
     }
@@ -142,5 +149,12 @@
     end
 
+    # set_descriptor_list ##
+
+    if @generate then
+      signature_plugin
+    end
+
     @@current_object = nil
+
     return self
   end
@@ -170,4 +184,9 @@
       when :DEVIATE
         @b_deviate = true
+      when :GENERATE
+        if @generate then
+          cdl_error( "S9999 generate specifier duplicate"  )
+        end
+        @generate = [ s[1], s[2] ] # [ PluginName, "option" ]
       else
         cdl_error( "S1002 \'$1\': unknown specifier for signature" , s[0] )
@@ -309,11 +328,57 @@
   end
 
-  #== Signature# 引数で参照されている Descriptor 型のリストを作成する
+  #=== Signature# シグニチャプラグイン (generate 指定子)
+  def signature_plugin
+    plugin_name = @generate[0]
+    option = @generate[1]
+    apply_plugin( plugin_name, option )
+  end
+
+  #== Signature#apply_plugin
+  def apply_plugin plugin_name, option
+    if is_empty? then
+      cdl_warning( "S9999 $1 is empty. cannot apply signature plugin. ignored" , @name )
+      return
+    end
+
+    plClass = load_plugin( plugin_name, SignaturePlugin )
+    return if plClass == nil
+    if $verbose then
+      print "new through: plugin_object = #{plClass.class.name}.new( #{@name}, #{option} )\n"
+    end
+
+    begin
+      plugin_object = plClass.new( self, option )
+      plugin_object.set_locale @locale
+    rescue Exception => evar
+      cdl_error( "S1150 $1: fail to new" , plugin_name )
+      print_exception( evar )
+    end
+    generate_and_parse plugin_object
+end
+
+  #== Signature# 引数で参照されている Descriptor 型のリストを
   #RETURN:: Hash { Signature => ParamDecl }:  複数の ParamDecl から参照されている場合、最後のものしか返さない
   def get_descriptor_list
+    @descriptor_list
+  end
+
+  @@set_descriptor_list = {}
+  def self.set_descriptor_list
+    Namespace.get_root.travers_all_signature{ |sig|
+      if @@set_descriptor_list[ sig ] == nil then
+        @@set_descriptor_list[ sig ] = true
+        sig.set_descriptor_list
+      end
+    }
+  end
+
+  #== Signature# 引数で参照されている Descriptor 型のリストを作成する
+  def set_descriptor_list
     desc_list = { }
     # p "has_desc #{@name}"
     fha = get_function_head_array                       # 呼び口または受け口のシグニチャの関数配列
     if fha == nil then                                  # nil の場合、自己参照によるケースと仮定
+      @descriptor_list = desc_list
       return desc_list
     end
@@ -330,5 +395,13 @@
             # p "has_desc #{param.get_name} #{t}"
             if t.kind_of? DescriptorType then
-              desc_list[t] = param
+              desc_list[ t.get_signature ] = param
+              # p self.get_name, t.get_signature.get_name
+              if t.get_signature == self then
+               # cdl_error( "S9999 Descriptor argument '$1' is the same signature as this parameter '$2' included", @name, param.get_name )
+              end
+              dir = param.get_direction
+              if dir != :IN && dir != :OUT && dir != :INOUT then
+                cdl_error( "S9999 Descriptor argument '$1' cannot be specified for $2 parameter", param.get_name, dir.to_s.downcase )
+              end
             end
           }
@@ -336,33 +409,19 @@
       end
     }
-    return desc_list
+    @descriptor_list = desc_list
   end
 
   #=== Signature# 引数に Descriptor があるか？
   def has_descriptor?
-    # p "has_desc #{@name}"
-    fha = get_function_head_array                       # 呼び口または受け口のシグニチャの関数配列
-    if fha == nil then                                  # nil の場合、自己参照によるケースと仮定
+    if get_descriptor_list == nil then
+      # end_of_parse が呼び出される前に has_descriptor? が呼び出された
+      # 呼び出し元は DescriptorType#initialize
+      # この場合、同じシグニチャ内の引数が Descriptor 型である
       return true
-    end
-    fha.each{ |fh|
-      fd = fh.get_declarator                            # fd: Decl  (関数頭部からDeclarotorを得る)
-      if fd.is_function? then                           # fd が関数でなければ、すでにエラー
-        params = fd.get_type.get_paramlist.get_items
-        if params then
-          params.each{ |param|
-            t = param.get_type.get_original_type
-            while( t.kind_of? PtrType )
-              t = t.get_referto
-            end
-            # p "has_desc #{param.get_name} #{t}"
-            if t.kind_of? DescriptorType then
-              return true
-            end
-          }
-        end
-      end
-    }
-    return false
+    elsif get_descriptor_list.length > 0 then
+      return true
+    else
+      return false
+    end
   end
 
@@ -411,4 +470,70 @@
 
 end
+
+module CelltypePluginModule
+  #=== Celltype# セルタイププラグイン (generate 指定子)
+  def celltype_plugin
+    plugin_name = @generate[0]
+    option = @generate[1]
+    @generate[2] = apply_plugin( plugin_name, option )
+  end
+
+  #=== Celltype# セルタイププラグインをこのセルタイプに適用
+  def apply_plugin( plugin_name, option )
+
+    # plClass = load_plugin( plugin_name, CelltypePlugin )
+    if kind_of? Celltype then
+      plugin_class = CelltypePlugin
+    elsif kind_of? CompositeCelltype then
+      plugin_class = CompositePlugin
+    else
+      raise "unknown class #{self.class.name}"
+    end
+    
+    plClass = load_plugin( plugin_name, plugin_class )
+    return if plClass == nil
+    if $verbose then
+      print "new celltype plugin: plugin_object = #{plClass.class.name}.new( #{@name}, #{option} )\n"
+    end
+
+    begin
+      plugin_object = plClass.new( self, option )
+      @generate_list << [ plugin_name, option, plugin_object ]
+      plugin_object.set_locale @locale
+      generate_and_parse plugin_object
+    rescue Exception => evar
+      cdl_error( "S1023 $1: fail to new" , plugin_name )
+      print_exception( evar )
+    end
+
+    # 既に存在するセルに new_cell を適用
+    @cell_list.each{ |cell|
+      apply_plugin_cell plugin_object, cell
+    }
+
+    return plugin_object
+  end
+
+  def apply_plugin_cell plugin, cell
+    begin
+      plugin.new_cell cell
+    rescue Exception => evar
+      cdl_error( "S1037 $1: celltype plugin fail to new_cell" , plugin.class.name )
+      print_exception( evar )
+    end
+  end
+
+  def celltype_plugin_new_cell cell
+    @generate_list.each{ |generate|
+      celltype_plugin = generate[2]
+      begin
+        celltype_plugin.new_cell cell
+      rescue Exception => evar
+        cdl_error( "S1037 $1: celltype plugin fail to new_cell" , celltype_plugin.class.name )
+        print_exception( evar )
+      end
+    }
+  end
+end #CelltypePluginModule
 
 class Celltype < NSBDNode # < Nestable
@@ -423,10 +548,13 @@
 # @ct_factory_list::    Factory[] :    celltype factory
 # @cell_list:: Cell[] : 定義のみ (V1.0.0.2 以降)
+# @ordered_cell_list:: Cell[] : ID 順に順序付けされたセルリスト、最適化以降有効 (リンク単位ごとに生成されなおす)
 # @singleton:: bool
 # @idx_is_id:: bool
 # @idx_is_id_act:: bool: actual value
+# @b_need_ptab:: bool: true if having cells in multi-domain
 # @active:: bool
 # @b_reuse:: bool :  reuse 指定されて import された(template 不要)
 # @generate:: [ Symbol, String, Plugin ]  = [ PluginName, option, Plugin ] Plugin は生成後に追加される
+# @generate_list:: [ [ Symbol, String, Plugin ], ... ]   generate 文で追加された generate
 #
 # @n_attribute_ro:: int >= 0    none specified
@@ -437,7 +565,11 @@
 # @n_var_omit:: int >= 0        # of [omit] specified vars # mikan var の omit は有？
 # @n_var_init:: int >= 0        # of vars with initializer
-# @n_call_port:: int >= 0
-# @n_call_port_array:: int >= 0
+# @n_call_port:: int >= 0       # dynamic ports are included
+# @n_call_port_array:: int >= 0  # dynamic ports are included
 # @n_call_port_omitted_in_CB:: int >= 0   最適化で省略される呼び口
+# @n_call_port_dynamic:: int >= 0  #
+# @n_call_port_array_dynamic:: int >= 0
+# @n_call_port_ref_desc:: int >= 0  #
+# @n_call_port_array_ref_desc:: int >= 0
 # @n_entry_port:: int >= 0
 # @n_entry_port_array:: int >= 0
@@ -455,5 +587,6 @@
 
   include PluginModule
-
+  include CelltypePluginModule
+  
   @@nest_stack_index = -1
   @@nest_stack = []
@@ -496,4 +629,5 @@
     @active = false
     @generate = nil
+    @generate_list = []
 
     @n_attribute_ro = 0
@@ -507,4 +641,8 @@
     @n_call_port_array = 0
     @n_call_port_omitted_in_CB = 0
+    @n_call_port_dynamic = 0
+    @n_call_port_array_dynamic = 0
+    @n_call_port_ref_desc = 0
+    @n_call_port_array_ref_desc = 0
     @n_entry_port = 0
     @n_entry_port_array = 0
@@ -528,16 +666,15 @@
     if $idx_is_id then
       @idx_is_id = true
+      @idx_is_id_act = true
+      @b_need_ptab = true
     else
       @idx_is_id = false
-    end
-    @idx_is_id_act = @idx_is_id
+      @idx_is_id_act = false
+      @b_need_ptab = false
+    end
 
     Namespace.new_celltype( self )
     set_namespace_path # @NamespacePath の設定
     set_specifier_list( Generator.get_statement_specifier )
-
-    if @singleton then
-      @idx_is_id_act = false
-    end
 
     @included_header = {}
@@ -577,4 +714,6 @@
       celltype_plugin
     end
+
+    # check_dynamic_join ##
 
     @@current_object = nil
@@ -592,4 +731,12 @@
       @n_call_port += 1
       @n_call_port_array += 1 if port.get_array_size != nil
+      if port.is_dynamic? then
+        @n_call_port_dynamic += 1
+        @n_call_port_array_dynamic += 1 if port.get_array_size != nil
+      end
+      if port.is_ref_desc? then
+        @n_call_port_ref_desc += 1
+        @n_call_port_array_ref_desc += 1 if port.get_array_size != nil
+      end
     else
       @n_entry_port += 1
@@ -753,4 +900,6 @@
       when :IDX_IS_ID
         @idx_is_id = true
+        @idx_is_id_act = true
+        @b_need_ptab = true
       when :ACTIVE
         @active = true
@@ -764,4 +913,8 @@
       end
     }
+    if @singleton then
+      @idx_is_id_act = false
+      @b_need_ptab = false
+    end
   end
 
@@ -863,28 +1016,121 @@
   end
 
-  #=== Celltype# セルタイププラグイン (generate 指定子)
-  def celltype_plugin
-
-    load_plugin( @generate[0], CelltypePlugin )
-
-    plugin_name = @generate[0]
-    option = @generate[1]
-    plugin_object = nil
-    eval_str = "plugin_object = #{plugin_name}.new( self, option )"
-    if $verbose then
-      print "new celltype : #{eval_str}\n"
-    end
-
-    begin
-      eval( eval_str )     # plugin を生成
-      plugin_object.set_locale @locale
-      @generate[ 2 ] = plugin_object
-      generate_and_parse plugin_object
-    rescue Exception => evar
-      cdl_error( "S1023 $1: fail to new" , plugin_name )
-      print "eval( #{eval_str} )\n"
-
-      print_exception( evar )
-    end
+  @@dynamic_join_checked_list = {}
+  def self.check_dynamic_join
+    Namespace.get_root.travers_all_celltype{ |ct|
+      if @@dynamic_join_checked_list[ ct ] == nil then
+        @@dynamic_join_checked_list[ ct ] = true
+        ct.check_dynamic_join
+      end
+    }
+  end
+
+  #=== Celltype#dynamic の適合性チェック
+  def check_dynamic_join
+    return if ! $verbose
+    @port.each{ |port|
+      signature = port.get_signature
+      next if signature == nil   # すでにエラー
+      if port.is_dynamic? then
+        dbgPrint( "[DYNAMIC] checking dynamic port: #{@global_name}.#{port.get_name}\n" )
+        # print( "[DYNAMIC] checking dynamic port: #{@global_name}.#{port.get_name}\n" )
+        next if find_ref_desc_port signature
+        next if find_descriptor_param signature, :DYNAMIC
+        cdl_warning( 'W9999 $1 cannot get information for dynamic port $2', @name, port.get_name )
+      elsif port.is_ref_desc? then
+        dbgPrint( "[DYNAMIC] checking ref_desc port: #{@global_name}.#{port.get_name}\n" )
+        # print( "[DYNAMIC] checking ref_desc port: #{@global_name}.#{port.get_name}\n" )
+        next if find_dynamic_port signature
+        next if find_descriptor_param signature, :REF_DESC
+        cdl_warning( 'W9999 $1 cannot put information from ref_desc port $2', @name, port.get_name )
+      elsif port.get_signature then
+        if port.get_signature.has_descriptor? then
+          port.get_signature.get_descriptor_list.each{ |signature, param|
+            dbgPrint( "[DYNAMIC] checking Descriptor parameter: #{@global_name}.#{port.get_name} ... #{param.get_name}\n" )
+            # print( "[DYNAMIC] checking Descriptor parameter: #{@global_name}.#{port.get_name} ... #{param.get_name}\n" )
+            if port.get_port_type == :CALL then
+              if param.get_direction == :IN
+                next if find_ref_desc_port signature
+                next if find_descriptor_param signature, :DYNAMIC
+              elsif param.get_direction == :OUT
+                next if find_dynamic_port signature
+                next if find_descriptor_param signature, :REF_DESC
+              end
+            else  # :ENTRY
+              if param.get_direction == :IN
+                next if find_dynamic_port signature
+                next if find_descriptor_param signature, :REF_DESC
+              elsif param.get_direction == :OUT
+                next if find_ref_desc_port signature
+                next if find_descriptor_param signature, :DYNAMIC
+              end
+            end
+            cdl_warning( 'W9999 "$1" cannot handle Descriptor "$2" information for port "$3"', @name, param.get_name, port.get_name )
+          }
+        end
+      end
+    }
+  end
+
+  def find_dynamic_port signature
+    dbgPrint "[DYNAMIC] find_dynamic_port signature=#{signature.get_name}"
+    @port.each{ |port|
+      dbgPrint "[DYNAMIC] port=#{port.get_name} signature=#{port.get_signature.get_name} dynamic=#{port.is_dynamic?}"
+      return port if port.is_dynamic? && port.get_signature == signature
+    }
+    return nil
+  end
+  def find_ref_desc_port signature
+    if signature == nil then  # すでにエラー
+      return nil
+    end
+    dbgPrint "[DYNAMIC] find_ref_desc_port signature=#{signature.get_name}"
+    @port.each{ |port|
+      dbgPrint "[DYNAMIC] port=#{port.get_name} signature=#{port.get_signature.get_name} ref_desc=#{port.is_ref_desc?}"
+      return port if port.is_ref_desc? && port.get_signature == signature
+    }
+    return nil
+  end
+  #=== Celltype#ディスクリプタ型でシグニチャが一致し dyn_ref に対応づく引数を探す
+  #dyn_ref::Symbol: :DYNAMIC=ディスクリプタを得る手段となる引数を探す．:REF_DESC=渡す手段となる引数を探す
+  def find_descriptor_param signature, dyn_ref
+    param_list = []
+    @port.each{ |port|
+      port.each_param{ |port, func, param|
+        type = param.get_type
+        while type.kind_of? PtrType
+          type = type.get_type
+        end
+        dbgPrint( "[DYNAMIC] dyn_ref=#{dyn_ref} port_type=#{port.get_port_type} dir=#{param.get_direction} paramName=#{param.get_name} paramType=#{type.class}\n" )
+        # print( "[DYNAMIC] dyn_ref=#{dyn_ref} port_type=#{port.get_port_type} dir=#{param.get_direction} paramName=#{param.get_name} paramType=#{type.class}\n" )
+        if type.kind_of? DescriptorType then
+          if type.get_signature == signature then
+            dir = param.get_direction
+            if dir == :INOUT then
+              dbgPrint( "[DYNAMIC] found INOUT Descriptor parameter: #{@global_name}.#{port.get_name} ... #{param.get_name}\n" )
+              # print( "[DYNAMIC] found INOUT Descriptor parameter: #{@global_name}.#{port.get_name} ... #{param.get_name}\n" )
+              return param
+            elsif dyn_ref == :DYNAMIC then
+              if dir == :IN && port.get_port_type == :ENTRY ||
+                 dir == :OUT && port.get_port_type == :CALL then
+                dbgPrint( "[DYNAMIC] found INBOUND Descriptor parameter: #{@global_name}.#{port.get_name} ... #{param.get_name}\n" )
+                # print( "[DYNAMIC] found INBOUND Descriptor parameter: #{@global_name}.#{port.get_name} ... #{param.get_name}\n" )
+                return param
+              end
+            elsif dyn_ref == :REF_DESC
+              if dir == :IN && port.get_port_type == :CALL ||
+                 dir == :OUT && port.get_port_type == :ENTRY then
+                dbgPrint( "[DYNAMIC] found OUTBOUND Descriptor parameter: #{@global_name}.#{port.get_name} ... #{param.get_name}\n" )
+                # print( "[DYNAMIC] found OUTBOUND Descriptor parameter: #{@global_name}.#{port.get_name} ... #{param.get_name}\n" )
+                return param
+              end
+            else
+              raise "unknown ref_desc"
+            end
+          end
+        end
+      }
+    }
+    return nil
   end
 
@@ -895,4 +1141,5 @@
   # シングルトンセルが同じ linkunit に複数ないかチェック
   def new_cell( cell )
+    dbgPrint "Celltype#new_cell( #{cell.get_name} )\n"
     # Celltype では Cell の set_owner しない
     # シングルトンで、プロトタイプ宣言でない場合、コード生成対象リージョンの場合
@@ -905,7 +1152,12 @@
     end
     @cell_list << cell
+
+    # プラグインにより生成されたセルタイプか ?
     if @plugin then
       @plugin.new_cell cell
     end
+
+    # セルタイププラグインの適用
+    celltype_plugin_new_cell cell
   end
 
@@ -919,7 +1171,14 @@
   #     呼び口（ただし、最適化で不要となるものは除く）
   def has_INIB?
-#    print "name=#{@name} @n_attribute_ro=#{@n_attribute_ro}  @n_var_size_is=#{@n_var_size_is} @n_call_port=#{@n_call_port} @n_call_port_omitted_in_CB=#{@n_call_port_omitted_in_CB} @n_entry_port_array_ns=#{@n_entry_port_array_ns}\n"
-    return $rom && (@n_attribute_ro > 0 || @n_var_size_is > 0 || ( @n_call_port - @n_call_port_omitted_in_CB ) > 0 || @n_entry_port_array_ns > 0)
-#    return $rom && (@n_attribute_ro > 0 || ( @n_call_port - @n_call_port_omitted_in_CB ) > 0)
+
+    result = $rom &&
+             (@n_attribute_ro > 0 ||
+              @n_var_size_is > 0 ||
+              ( @n_call_port - @n_call_port_omitted_in_CB - (@n_call_port_dynamic-@n_call_port_array_dynamic) ) > 0 ||
+              $ram_initializer && @n_call_port_dynamic > 0 ||
+              @n_entry_port_array_ns > 0)
+    # print "name=#{@name} n_attribute_ro=#{@n_attribute_ro}  n_var_size_is=#{@n_var_size_is} n_call_port=#{@n_call_port} n_call_port_omitted_in_CB=#{@n_call_port_omitted_in_CB} n_call_port_dynamic=#{@n_call_port_dynamic} n_call_port_array_dynamic=#{@n_call_port_array_dynamic} n_entry_port_array_ns=#{@n_entry_port_array_ns} has_INIB?=#{result}\n"
+
+    return result
   end
 
@@ -934,5 +1193,5 @@
   def has_CB?
     if $rom then
-      return @n_attribute_rw > 0 || (@n_var-@n_var_size_is) > 0
+      return @n_attribute_rw > 0 || (@n_var-@n_var_size_is) > 0 || (@n_call_port_dynamic - @n_call_port_array_dynamic) > 0
       # return @n_attribute_rw > 0 || @n_var > 0
     else
@@ -943,5 +1202,5 @@
   #=== Celltype# SET_CB_INIB_POINTER, INITIALIZE_CB が必要か
   def need_CB_initializer?
-    @n_var_init > 0 || has_CB?
+    @n_var_init > 0 || has_CB? || ( @n_call_port_dynamic && $ram_initializer )
   end
 
@@ -998,4 +1257,12 @@
   def is_active?
     @active
+  end
+
+  def idx_is_id_act?
+    @idx_is_id_act
+  end
+
+  def multi_domain?
+    @b_need_ptab
   end
 
@@ -1120,4 +1387,5 @@
 #                                               逆require ポートに対して複数の結合がないかチェックする
 # @generate:: [ Symbol, String, Plugin ]  = [ PluginName, option, Plugin ] Plugin は生成後に追加される
+# @b_post_code_generated:: Bool: true if generated in tmp_plugin_post_code.cdl
 #
 # composite のためインスタンス変数
@@ -1142,5 +1410,7 @@
 # @id:: Integer : コード生成直前に設定  (プロトタイプ宣言の場合は -1 のまま放置)
 # @id_specified::Integer : 指定された id
-# @restrict_list::{ entry_name => { func_name, [ region_name, ... ] } }
+# @restrict_list::{ entry_name => { func_name, [ region_path_str, ... ] } }
+# @restrict_list2::{ entry_name => { func_name, [ domain_root_region, ... ] } }
+# @b_restrict_referenced::Bool: restrict_list が参照れた
 
 =begin
@@ -1187,11 +1457,4 @@
   end
 
-
-  # composite で clone されたもの（子孫まで含む）
-  # Join.change_rhs_port にて CompoisteCelltype 内の Join の結合先を変更する際に使用
-  @@cloned_cell_list = {}
-  ### mikan BUG @@cloned_cell_list は composite の階層ごとに記憶していないため、同じ名前が内部に現れると、うまく動作しない
-  # change_rhs_port の実装は、こんな回りくどいことをする必要はなかった。右辺に現れるセル名には、composite のセル名を前につなげるだけでよかった
-
   def initialize( ct_path, in_composite = false )
     super()
@@ -1233,4 +1496,7 @@
     @referenced_port_list = {}
     @restrict_list = {}
+    @restrict_list2 = {}
+    @b_restrict_referenced = false
+    @b_post_code_generated = false
 
     @cell_list = {}
@@ -1258,5 +1524,5 @@
       cell_prev = CompositeCelltype.find( name )
       if cell_prev == nil then
-        CompositeCelltype.new_cell( self )
+        CompositeCelltype.new_cell_in_composite( self )
       end
     else
@@ -1437,4 +1703,5 @@
 
     else
+      dbgPrint "new_join: cell=#{@name} add_item=#{join.get_name}\n"
       # join
       @join_list.add_item( join )
@@ -1500,5 +1767,10 @@
 
         # 呼び口側のセルと、そのセルタイプ
-        cell = Namespace.find cp_cell_nsp
+        if ! @in_composite then
+          cell = Namespace.find cp_cell_nsp
+        else
+          cell = CompositeCelltype.find cp_cell_nsp.to_s.to_sym
+        end
+
         if ! cell.instance_of? Cell then
           cdl_error( "S9999 '$1': not cell for reverse join", cp_cell_nsp.get_path_str )
@@ -1510,5 +1782,11 @@
         end
 
-        ep_cell_nsp = get_namespace_path
+        if ! @in_composite then
+          ep_cell_nsp = get_namespace_path
+          ep_cell_nsp_str = ep_cell_nsp.get_path_str
+        else
+          ep_cell_nsp = NamespacePath.new @name, false
+          ep_cell_nsp_str = @name
+        end
         ep_subscript_val = ep_subscript ? ep_subscript.eval_const( nil ) : nil
         rhs = Expression.create_cell_join_expression( ep_cell_nsp, ep_subscript_val, ep_name, rj.get_locale )
@@ -1521,5 +1799,5 @@
           ss_str = ""
         end
-        dbgPrint "create_reverse_join: #{cell.get_name}.#{cp_name}#{ss_str} => #{ep_cell_nsp.get_path_str}.ep_name\n"
+        dbgPrint "create_reverse_join: #{cell.get_name}.#{cp_name}#{ss_str} => #{ep_cell_nsp_str}.#{ep_name}\n"
       }
     end
@@ -1565,4 +1843,7 @@
       set_specifier_list( Generator.get_statement_specifier )
     end
+    if TECSGEN.post_coded?
+      @b_post_code_generated = true
+    end
     set_f_def f_def
 
@@ -1581,5 +1862,6 @@
 
     if ! @in_composite then
-      if @celltype.instance_of? Celltype then
+      # if @celltype.instance_of? Celltype then
+      if @celltype then  # composite でも呼びだす, エラー時 nil
         @celltype.new_cell self
       end
@@ -1702,28 +1984,31 @@
   end
 
-  #=== Cell# セルタイププラグイン (generate 指定子)
+  #=== Cell# セルプラグイン (generate 指定子)
   def cell_plugin
-
-    load_plugin( @generate[0], CellPlugin )
-
     plugin_name = @generate[0]
     option = @generate[1]
-    plugin_object = nil
-    eval_str = "plugin_object = #{plugin_name}.new( self, option )"
+    @generate[2] = apply_plugin plugin_name, option
+  end
+
+  def apply_plugin plugin_name, option
+    if ! @b_defined then
+      cdl_error( "S9999 plugin cannot apply to prototype cell '$1'", @name )
+    end
+
+    plClass = load_plugin( plugin_name, CellPlugin )
+    # return if plClass == nil # 従来と仕様が変わるので、継続する
     if $verbose then
-      print "new cell : #{eval_str}\n"
+      print "new cell plugin: plugin_object = #{plClass.class.name}.new( #{@name}, #{option} )\n"
     end
 
     begin
-      eval( eval_str )     # plugin を生成
+      plugin_object = plClass.new( self, option )
       plugin_object.set_locale @locale
-      @generate[ 2 ] = plugin_object
       generate_and_parse plugin_object
     rescue Exception => evar
       cdl_error( "S1166 $1: fail to new", plugin_name )
-      print "eval( #{eval_str} )\n"
-
       print_exception( evar )
     end
+    return  plugin_object
   end
 
@@ -1742,11 +2027,10 @@
 
     # debug
-    dbgPrint "Cell#clone_for_composite : cloning: #{@name} #{global_name}  b_defined=#{@b_defined}\n"
+    dbgPrint "  CLONING Cell#clone_for_composite : cloning: #{@name} #{global_name}  b_defined=#{@b_defined} #{self}=>#{@my_clone} \n"
+    dbgPrint "              my_name=#{@name} name=#{name} owner class=#{@owner.class.name}\n"
 
     @my_clone = self.clone
-    @@cloned_cell_list[ self ] = @my_clone
 
     # clone したセルの内部に持つ名前情報を調整する
-
     @my_clone.set_cloned( name, global_name, namespacePath, join_array, ct_name, region, plugin, locale )
 
@@ -1772,5 +2056,5 @@
     # debug
     dbgPrint "cell.set_cloned : global_name: #{global_name}  name: #{name}  @name: #{@name}\n"
-
+    dbgPrint "set_cloned:  entry_array_max_subscript.len=#{@entry_array_max_subscript.length}\n"
     @global_name = :"#{global_name}_#{@name}"
     @name = :"#{name}_#{@name}"
@@ -1796,5 +2080,5 @@
     @alloc_list = []
     @require_joined_list = {}
-    @entry_array_max_subscript = {}
+    @entry_array_max_subscript = @entry_array_max_subscript.dup
     @cell_list = {}
     @cell_list2 = []
@@ -1805,4 +2089,12 @@
       @join_list.change_item j
     }
+  end
+
+  #=== clone されたセルが composite の場合、内部セルを展開する
+  #self:: clone されたセルでなければならない
+  def expand_inner
+    if ! @f_cloned then
+      raise "expnad_inner: not cloned cell"
+    end
 
     # clone しようとするセルが composit セルタイプ？
@@ -1811,25 +2103,16 @@
       @cell_list, @cell_list2 = @celltype.expand( @name, @global_name, @NamespacePath, @join_list, @region, @plugin, @locale )
     end
-
   end
 
   #=== Cell# clone された cell の join_list の右辺の変更
   #  呼び口の右辺の cell を他の clone された cell に置換え
-  def change_rhs_port
+  def change_rhs_port cloned_cell_list
 
     # debug
-    dbgPrint "Cell change_rhs_port: global_name: #{@global_name}\n"
+    dbgPrint "=====   Cell#change_rhs_port: name=#{@name}   =====\n"
 
     @join_list.get_items.each { |j|
-      j.change_rhs_port( @@cloned_cell_list, @celltype )
-    }
-
-    if @celltype.instance_of?( CompositeCelltype ) then
-
-      # 入れ子のセルについても変更
-      @cell_list.each{ |name,c|
-        c.change_rhs_port
-      }
-    end
+      j.change_rhs_port( cloned_cell_list, @celltype )
+    }
   end
 
@@ -1891,4 +2174,18 @@
   def is_in_composite?
     @in_composite
+  end
+
+  #=== Cell# composite のセルか？
+  def is_of_composite?
+    if @celltype.kind_of? CompositeCelltype
+      return true
+    else
+      return false
+    end
+  end
+
+  #=== Cell# tmp_plugin_post_code.cdl で生成されたセルか？
+  def post_code_generated?
+    @b_post_code_generated
   end
 
@@ -1980,4 +2277,6 @@
 
       # セルタイプ内で port_name の CompositeCelltypeJoin を探す（コード生成段階では必ず見つかる）
+      # print "get_real_cell: cell=#{@name} port=#{port_name}\n"
+      # pp @cell_list
       cj = @celltype.find_export( port_name )
 
@@ -1991,4 +2290,13 @@
   end
 
+  #=== Cell#get_real_celltype
+  #
+  def get_real_celltype( port_name )
+    if @celltype.instance_of?( CompositeCelltype ) then
+      return @celltype.get_real_celltype port_name
+    else
+      return @celltype
+    end
+  end
 
   #=== Cell# 受け口のport の参照カウントをアップする
@@ -2033,4 +2341,16 @@
   end
 
+  #Cell#属性の初期値を得る
+  #attr_name::Symbol  必ず初期化されていないと Ruby 例外となる
+  def get_attr_initializer attr_name
+    val = @join_list.get_item( attr_name )
+    if val == nil then
+      val = (@celltype.find  attr_name).get_initializer
+    else
+      val = val.get_rhs
+    end
+    return val
+  end
+
   def get_celltype
     @celltype
@@ -2075,10 +2395,13 @@
   #=== Cell# composite の内側セルの受け口配列の添数の最大値を設定
   def set_entry_inner_port_max_subscript( port, num )
-    if @cell_list == nil then   # mikan これって問題ない？
-      return    # プロトタイプ宣言しかされていなくて、内側セルが展開されていない
+    if @cell_list == nil then
+      return    # プロトタイプ宣言しかされていなくて、内側セルが展開されていない　or composite 展開前
     end
 
     # composite の内側のセルに伝播
     if @celltype.instance_of? CompositeCelltype then
+      dbgPrint "set_entry_inner_port_max_subscript #{@name} #{@port} #{num} cell_list.len=#{@cell_list.length}\n"
+      # @cell_list.each{ |c, p| print c, p, '\n' }
+
       cj = @celltype.find_export port.get_name
       if cj && @cell_list[ cj.get_cell_name.to_s ] then
@@ -2278,6 +2601,12 @@
         else
           cell = j.get_rhs_cell2
-          next if cell == nil     # 右辺が見つからなかった．既にエラー
+          next if cell == nil || cell.get_celltype == nil     # 右辺が見つからなかった．既にエラー
           port = cell.get_celltype.find( j.get_rhs_port2 )
+          if port == nil then
+            dbgPrint "set_port_ref: #{@name}.#{j.get_name} = #{cell.get_name}.#{j.get_rhs_port2}\n"
+            # through プラグインで生成されたセルの受け口が見つからないケース (のハズ)
+            cdl_error( "entry '$1' not found in '$2' refered from $3.$4", j.get_rhs_port2, cell.get_name, @name, j.get_name )
+            next
+          end
           dbgPrint( "set_port_reference_count: #{@name}.#{j.get_name} => #{cell.get_name}.#{port.get_name}\n")
           cell.port_referenced port
@@ -2672,4 +3001,5 @@
           }
         else
+          dbgPrint "set_definition_join: #{@name}.#{join.get_name} celltype=#{@celltype.get_name}\n"
           join.set_definition( @celltype.find(join.get_name) )
         end
@@ -2687,15 +3017,4 @@
       expand
     end
-
-    # celltype に generate が指定されされているか
-    celltype_plugin = @celltype.get_celltype_plugin
-    if celltype_plugin then
-      begin
-        celltype_plugin.new_cell self
-      rescue Exception => evar
-        cdl_error( "S1037 $1: celltype plugin fail to new_cell" , celltype_plugin.class.name )
-        print_exception( evar )
-      end
-    end
   end
 
@@ -2705,8 +3024,5 @@
 
     #debug
-    dbgPrint "expanding #{@name} #{@celltype.get_name}\n"
-
-    # 展開されたセルのリスト
-    @@cloned_cell_list = {}
+    dbgPrint "=====    expanding   #{@name}     =====\n"
 
     # composite celltype の cell を展開
@@ -2718,10 +3034,17 @@
       set_f_ref
     end
-
-    # 呼び口の右辺のセルを clone したものに変更
-    self.change_rhs_port
+  end
+
+  #=== Cell#内部セルの受け口添数最大値を設定
+  def set_max_entry_port_inner_cell
+    if @cell_list == nil then
+      return
+    end
+
+    dbgPrint "set_max_entry_port_inner_cell name=#{@name} entry_array_max_subscript.len=#{@entry_array_max_subscript.length}\n"
 
     # プロトタイプ宣言で設定されていたものを反映する
     @entry_array_max_subscript.each{ |port,name|
+      dbgPrint "set_entry_inner_port_max_subscript( #{port}, #{name} )\n"
       set_entry_inner_port_max_subscript( port, name )
     }
